#!/usr/bin/php -q
<?
//////////////////////////////////////////////////////////////////////
////
////  MAHC - MAHC Advanced Html Chat Version 1.0.0
////  Complex Chat System Written in PHP4 Supporting HTML-only clients
////  Copyright (C) 2001 Joseph Durbin <jdurbin@users.sourceforge.net>
////  This Source is GNU GPL, See file LICENSE in distribution.
////
//////////////////////////////////////////////////////////////////////
	// accountscronjob.php  Set a Crontab entry to run this file once a
	// day to remove old, unused accounts

include("manageaccounts.inc"); 

$AccountsFile=fopen("accounts","r");
if (!($AccountsFile)) die ("Couldn't Open accounts... please report if problem persists...");
flock($AccountsFile,LOCK_SH);
$y=0;
while (!feof($AccountsFile)) {
	$Line=fgetcsv($AccountsFile,255,":");
	$File[$y][0]=$Line[0];
	$File[$y][1]=$Line[1];
	$File[$y][2]=$Line[2];
	if ($Line[0]!="") $y++;			
};
flock($AccountsFile,LOCK_UN);
fclose($AccountsFile);

for ($i=0; $i<$y; $i++) {
	if (time()-$File[$i][2]>3000000) { //remove old user
		RemoveAccount($File[$i][0]);
	}
}

?>
