<?
	// cardgames.inc    Library for Common Card Game Functions
        // Currently not used in any game modules!
	// setup all 52 cards in order with room in deck 
	// array for MAIN DECK/PLAYED CARDS/PLAYER1 HAND/PLAYER2 HAND
	function SetupDeck() {
		$FACE[0]="H"; $FACE[1]="D"; $FACE[2]="C"; $FACE[3]="S"; 
		for ($i=0; $i<=52; ++$i) {
			$DECK[$i][0]="";
			$DECK[$i][1]="";
			$DECK[$i][2]="";
			$DECK[$i][3]="";
		}
		for ($i=0; $i<=3; ++$i) {
			$DECK[$i*13+0][0]=$FACE[$i]."A";
			for ($j=2; $j<=10; ++$j) 
				$DECK[$i*13+$j][0]=$FACE[$i].$j;
			$DECK[$i*13+10][0]=$FACE[$i]."J";
			$DECK[$i*13+11][0]=$FACE[$i]."Q";
			$DECK[$i*13+12][0]=$FACE[$i]."K";
		}
		return $DECK;
	}

	// Shuffle The Deck Cards (2 at a time, 1000 times)
	function Shuffle($DECK) {
		mt_srand(time());
		for ($i=0; $i<=1000; ++$i) {
			$j=mt_rand(0,51);
			$k=mt_rand[0,51);
			$TEMP=$DECK[$j][0];
			$DECK[$j][0]=$DECK[$k][0];
			$DECK[$k][0]=$TEMP;
		}
		return $DECK;
	}

	// outputs string containing 3 images that make up card image
	function DrawCard($CARD) {
		$IMAGES="";
		$CARD=strtolower($CARD);
		$CARD=chunk_split($CARD,1);
		$IMAGES.="<IMG BORDER=0 SRC=cards-$CARD[0]t.gif><BR>";
		if ($CARD[0]=="h" || $CARD[0]=="d")
	                $IMAGES.="<IMG BORDER=0 SRC=cards-r$CARD[1].gif><BR>";
		if ($CARD[0]=="c" || $CARD[0]=="s")
	                $IMAGES.="<IMG BORDER=0 SRC=cards-b$CARD[1].gif><BR>";
		$IMAGES.="<IMG BORDER=0 SRC=cards-$CARD[0]b.gif>";
		return $IMAGES;
	}
?>
