<?
//////////////////////////////////////////////////////////////////////
////
////  MAHC - MAHC Advanced Html Chat Version 1.0.0
////  Complex Chat System Written in PHP4 Supporting HTML-only clients
////  Copyright (C) 2001 Joseph Durbin <jdurbin@users.sourceforge.net>
////  This Source is GNU GPL, See file LICENSE in distribution.
////
//////////////////////////////////////////////////////////////////////
	// mahc.php  logs in/sets up user into mahc system
	// and builds frames with welcome.php in left half
	// chatwatch.php in lower right and chatpanel.php in upper right

	include("managecurrentusers.inc");
	include("manageaccounts.inc");
	include("prefs.inc");
	
	// Generates a random character string (lower/uppercase letters or numbers)
	// For use as a session code.  (System does not require cookies!)
	function GenCode() {
		$CODE="";
		srand(time());
		for ($i=0; $i<=7; ++$i) {
			$SWITCH=rand(1,3);
			if ($SWITCH==1) $CODE.=chr(rand(48,57));
			else if ($SWITCH==2) $CODE.=chr(rand(65,90));
			else $CODE.=chr(rand(97,122));
		}
		return $CODE;
	}

	// Print Errors in a consistent fashion
	function LoginError($text) {
		include("prefs.inc");
		print "<CENTER><TABLE CELLPADDING=10 BORDER=1 CELLSPACING=0 WIDTH=400>";
		print "<TR><TD BGCOLOR=$SHADOW1><B><CENTER>";
		print "$ERRORFONT $text</TD></TR></TABLE><BR>";
		include("index.php");
		exit();
	}

	// account names/passwords are case-insensitive
	$USERNAME=strtolower($USERNAME);
	$PASSWORD=strtolower($PASSWORD);
	$USERNAME=ucwords($USERNAME);
	if (!ereg("^[a-zA-Z]([a-zA-Z0-9]{2,11})$",$USERNAME)) {
		LoginError("Username \"$USERNAME\" Invalid, must start with a letter and be between 3 and 12 letters long.<BR>");
	} else if (!ereg("^([a-zA-Z0-9]{6,12})$",$PASSWORD)) {
		LoginError("Password Invalid, must start with letter and be between 6 and 12 letters/numbers long.<BR>");
	} else {
		$AccountsFile=fopen("accounts","r");
		if (!($AccountsFile)) die ("File \"accounts\" Could not be opened. please report to System Admin if Problem Persists.");
		flock($AccountsFile,LOCK_SH);
		$AccountsFileFound=0; //Is account in file? 1 if so
		while ((!feof($AccountsFile))&&($AccountsFileFound==0)) {
			$AccountsFileLine=fgetcsv($AccountsFile,30,":");
			if (strcasecmp($USERNAME,$AccountsFileLine[0])==0)
				$AccountsFileFound=1;
		};
		flock($AccountsFile,LOCK_UN);
		fclose($AccountsFile);		

                if (isset($NEWACCOUNT)) {  //Account Taken, do not add
			if ($AccountsFileFound==1) {
				LoginError("Username Taken, Please Choose Another."); 
			} else {  //Add Account
				$AccountsFile=fopen("accounts","a");
				flock($AccountsFile,LOCK_EX);
				if (CRYPT_STD_DES) {  //use standard des if available
					$PASSWORD=crypt($PASSWORD,substr(GenCode(),0,2));
				}
				fputs($AccountsFile,"$USERNAME:$PASSWORD:".time()."\n");
				flock($AccountsFile,LOCK_UN);
				fclose($AccountsFile);
			};
		} else {
			if ($AccountsFileFound==1) {
				if (CRYPT_STD_DES) {  // Use standard DES ifavailable
					$PASSWORD=crypt($PASSWORD,substr($AccountsFileLine[1],0,2));
				}
				if (strcasecmp($AccountsFileLine[1],$PASSWORD)==0) {
					
				} else {
					LoginError("Password Incorrect, Please Try Again.");
				}
			} else {
				LoginError("Username not found, Please Try Again, or  make a new account.");	
			};
		};
	};
	// Add account to Current User List(user:code:room:partner:game:time)
	$CODE=GenCode();  // Generate Random Session Code
	SetAccount($USERNAME,$PASSWORD,time());  //update account last login time
	SetUser($USERNAME,$CODE,"TheLobby","","",time());
	// Log Logins (username:IP:date
	$LogFile=fopen("mahc.log","a");
	if (!($LogFile)) die ("Could not open log file.  Please Report.");
	flock($LogFile,LOCK_EX);
	$DATE=time();
	fputs($LogFile,"$USERNAME	$REMOTE_ADDR	".gethostbyaddr($REMOTE_ADDR)."	$DATE\n");
	flock($LogFile,LOCK_UN);
	fclose($LogFile);
	// Message the lobby announcing the user's login
	include("message.inc");
        Message("F.Y.I.","TheLobby","ALL","$USERNAME has just logged on to the Chat!(".date("g:iA").").  :)",0);
        
	sleep(1); // helps make sure account is in current users and everythings good.

  // HTML Following Creates the Main Frames structure for site.
?>
<HTML><HEAD><TITLE>(( MAHC CHAT ))</TITLE></HEAD>
<FRAMESET BORDER=1 COLS=50%,50% FRAMEBORDER=0 FRAMESPACING=1 SCROLLING=auto>
<FRAME BORDER=0 FRAMEBORDER=0 NAME=LEFT SCROLLING=auto SRC="welcome.php?USERNAME=<? print "$USERNAME&CODE=$CODE"; ?>">
<FRAME BORDER=0 FRAMEBORDER=0 NAME=RIGHT SCROLLING=auto SRC="chatsetup.php?ROOM=TheLobby&USERNAME=<? print"$USERNAME&CODE=$CODE"; ?>">
<NOFRAMES>Sorry, but this site requires a "Frames Capable Browser"
and it appears yours is not.  You would need to upgrade</NOFRAMES>
</FRAMESET>
</HTML>

