<?
//////////////////////////////////////////////////////////////////////
////
////  MAHC - MAHC Advanced Html Chat Version 1.0.0
////  Complex Chat System Written in PHP4 Supporting HTML-only clients
////  Copyright (C) 2001 Joseph Durbin <jdurbin@users.sourceforge.net>
////  This Source is GNU GPL, See file LICENSE in distribution.
////
//////////////////////////////////////////////////////////////////////
	// messaging.php    Web Based Messages left for chat users

	//// Verify Corrent Session ID Code. (prevent Hijacking of ID!)
	include("verifysessioncode.inc");
	VerifySessionCode($USERNAME,$CODE);
	require("prefs.inc");
	
	function AccountExists($USERNAME) {
		$AccountsFile=fopen("accounts","r");
		if (!($AccountsFile)) die ("File \"accounts\" Could not be opened. please report to System Admin if Problem Persists.");
		$AccountsFileFound=0; //Is account in file? 1 if so
		while ((!feof($AccountsFile))&&($AccountsFileFound==0)) {
			$AccountsFileLine=fgetcsv($AccountsFile,30,":");
			if (strcasecmp($USERNAME,$AccountsFileLine[0])==0)
				$AccountsFileFound=1;
		};
		fclose($AccountsFile);
		if (strlen($USERNAME)==0) $AccountsFileFound=0;
		return $AccountsFileFound;  
	}

	function SendMessage($USERNAME,$TO,$MESSAGE) {
		$DataFile=fopen("data/$TO.messaging","a");
		if (!($DataFile)) die ("Could not open messaging datafile! Please report if problem persists.");
		fputs($DataFile,"$USERNAME|1|".time()."|$MESSAGE\n");
		fclose($DataFile);
	}
	
	function DeleteMessage($USERNAME,$DELETE) {
		$DataFile=fopen("data/$USERNAME.messaging","r");
		if (!($DataFile)) die ("Error opening messaging file."); 
		$i=0;	
		while (!feof($DataFile)) {
			$Line[$i]=fgets($DataFile,500);
			++$i;
		}
		$i-=2;
		fclose($DataFile);
		/// now delete
		$DataFile=fopen("data/$USERNAME.messaging","w");
		if (!($DataFile)) die ("Error opening messaging file."); 
		for ($j=0; $j<=$i; $j++) {	
			if ($j!=$DELETE) fputs($DataFile,$Line[$j]);
		}
		fclose($DataFile);
	}
	
	function DisplayMessaging($USERNAME,$CODE) {
		include("prefs.inc");
		if (file_exists("data/$USERNAME.messaging")&&(filesize("data/$USERNAME.messaging")!=0)) {
			$DataFile=fopen("data/$USERNAME.messaging","r");
			if (!($DataFile)) die ("Error opening messaging file."); 
			$i=0;	
			while (!feof($DataFile)) {
				$Line=fgetcsv($DataFile,500,"|");
				$Messages[$i][0]=$Line[0];
				$Messages[$i][1]=$Line[1];
				$Messages[$i][2]=$Line[2];
				$Messages[$i][3]=$Line[3];
				++$i;
			}
			$i-=2;
			fclose($DataFile);		
			print "<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=1 BGCOLOR=$SHADOW2>";
			print "<TR BGCOLOR=$ACCENT2><TD><B>NUM</TD><TD><B>FROM</TD><TD><B>MESSAGE TEXT</TD></TR>";
			for ($j=$i; $j>=0; $j--) {
				$k=$j+1;
				print "<TR><TD>$SMALLFONT<CENTER><A HREF=\"messaging.php?USERNAME=$USERNAME&CODE=$CODE&REPLY={$Messages[$j][0]}\">REPLY</A><BR><B>#$k</B><BR><A HREF=\"messaging.php?USERNAME=$USERNAME&CODE=$CODE&DELETE=$j\">DEL</A></TD>";
				print "<TD>$SMALLFONT<CENTER><B>{$Messages[$j][0]}</B><BR>".date("n/j/y",$Messages[$j][2])."<BR>".date("g:i A",$Messages[$j][2])."</TD>";
				print "<TD>$SMALLFONT{$Messages[$j][3]}</TD></TR>";
			}
			print "</TABLE>";
		} else print "<B>YOU HAVE NO MESSAGES.</B><BR>";
	}

	function ComposeMessaging($USERNAME,$REPLY,$CODE) {
		include ("prefs.inc");
		print "<TABLE BORDER=1 CELLPADDING=2 CELLSPACING=0 BGCOLOR=$ACCENT2><FORM ACTION=messaging.php METHOD=POST>";
		print "<INPUT TYPE=HIDDEN NAME=USERNAME VALUE=$USERNAME>";
		print "<INPUT TYPE=HIDDEN NAME=CODE VALUE=$CODE>";
		print "<INPUT TYPE=HIDDEN NAME=SENDMESSAGE VALUE=1>";
		print "<TR><TD><B>COMPOSE MESSAGE TO:</B><INPUT TYPE=TEXT NAME=TO VALUE=$REPLY></TD></TR>";
		print "<TR><TD><TEXTAREA ROWS=4 COLS=40 NAME=MESSAGE></TEXTAREA></TD></TR>";
		print "<TR><TD><CENTER><INPUT TYPE=SUBMIT VALUE=\"SEND MESSAGE\"></TD></TR>";
		print "</TABLE>";
	}

?>

<?
	print "<HTML><HEAD>
$HEADERA
$HEADERB
$HEADERC
</HEAD>
	<BODY BGCOLOR=$BACKGROUND VLINK=$VLINK HLINK=$HLINK ALINK=$ALINK><CENTER><B>$TITLEFONT".strtoupper($PROGRAM)." MESSAGING</FONT></B><BR><HR>$FONT";
	if ($SENDMESSAGE==1) {
		$TO=strtolower($TO);
		$TO=ucwords($TO);
		if ($MESSAGE=="") print "$ERRORFONT No Message Text Entered, Message Not Sent."; 
		else if (AccountExists($TO)==1) {
			$MESSAGE=strip_tags($MESSAGE);
			$MESSAGE=stripcslashes($MESSAGE);
			$MESSAGE=str_replace("\n","<BR>",$MESSAGE);
			SendMessage($USERNAME,$TO,$MESSAGE,$CODE);
			print "$ERRORFONT<B>Message Sent to $TO.</FONT><BR>";	
		} else print "$ERRORFONT<B>User \"$TO\" Does not exist!</FONT><BR>";	

	}
	if (isset($DELETE)) {
		DeleteMessage($USERNAME,$DELETE);
		$k=$DELETE+1;
		print "$ERRORFONT<B>Message #$k Deleted.</B></FONT><BR>";	
	}
	if (isset($REPLY)) ComposeMessaging($USERNAME,$REPLY,$CODE);
	else ComposeMessaging($USERNAME,"",$CODE);
	print "<BR>";
	DisplayMessaging($USERNAME,$CODE);
	print "<BR><HR>";
	print "<A HREF=\"messaging.php?USERNAME=$USERNAME&CODE=$CODE\">REFRESH</A> - ";
	print "<A HREF=\"welcome.php?USERNAME=$USERNAME&CODE=$CODE\">BACK TO MAIN AREA</A>";
	print "</BODY></HTML>";
?>
