<?
//////////////////////////////////////////////////////////////////////
////
////  MAHC - MAHC Advanced Html Chat Version 1.0.0
////  Complex Chat System Written in PHP4 Supporting HTML-only clients
////  Copyright (C) 2001 Joseph Durbin <jdurbin@users.sourceforge.net>
////  This Source is GNU GPL, See file LICENSE in distribution.
////
//////////////////////////////////////////////////////////////////////
	//chataction.php  Main chat actions (panel) handling

	//// Verify Corrent Session ID Code. (prevent Hijacking of ID!)
	include("verifysessioncode.inc");
	VerifySessionCode($USERNAME,$CODE);

	include("managecurrentusers.inc");
	include("message.inc");
	$TEXT=stripcslashes($TEXT);
	$TEXT=strip_tags($TEXT);
	if (strlen($TEXT)>250) $TEXT=substr($TEXT,0,250)." (Msg Clipped Because Too Long!)";
	$REJECTED=str_replace(" ","%20",$TEXT);
	switch($OPERATION) {
		case "Send Message":
			include("chatfilter.inc");
			if (ChatFilter($TEXT)==1) {
				$STATUS="Vulgarity Detected, not allowed in public rooms.";
			} else {
				$REJECTED="";
				$TEXT="<FONT COLOR=$CHATCOLOR>".$TEXT."</FONT>";
				Message($USERNAME,$ROOM,$WHO,$TEXT,0);
				$STATUS="Message Successfully Sent To $WHO.";
			}
			break;
		case "Private Chat":
			if ($WHO=="ALL") { $STATUS="Must Pick Someone To Invite!"; break; };
			$WHOCODE=GetCode($WHO);
			$TEXT=sprintf("%s invites you to Private Chat. click <A HREF=\"chataction.php?USERNAME=%s&CODE=%s&ROOM=%s&WHO=%s&OPERATION=AcceptPrivateChat\" TARGET=LEFT>HERE</A> to accept.",$USERNAME,$WHO,$WHOCODE,$ROOM,$USERNAME,$TEXT);
			Message($USERNAME,$ROOM,$WHO,$TEXT,1);
			$STATUS="Private Chat Invitation Sent To $WHO.";
			break;
		case "AcceptPrivateChat":
			$CODE=GetCode($WHO);
			$TEXT=sprintf("%s Accepts Your Invitation Click <A HREF=\"privatechat.php?USERNAME=%s&OPPONENT=%s&CODE=%s\" TARGET=LEFT>HERE</A> to Begin.",$USERNAME,$WHO,$USERNAME,$CODE);
			Message($USERNAME,$ROOM,$WHO,$TEXT,1);
			$CODE=GetCode($USERNAME);
			$TIME=GetTime($USERNAME);
			SetUser($USERNAME,$CODE,$ROOM,$WHO,"privatechat",$TIME);
			$CODE=GetCode($WHO);
			$TIME=GetTime($WHO);
			SetUser($WHO,$CODE,$ROOM,$USERNAME,"privatechat",$TIME);
			$CODE=GetCode($USERNAME);
			header("Location: privatechat.php?USERNAME=$USERNAME&OPPONENT=$WHO&CODE=$CODE");
			exit;
		case "Play TicTacToe":
			if ($WHO=="ALL") { $STATUS="Must Pick Someone To Invite!"; break; };
			$WHOCODE=GetCode($WHO);
			$TEXT=sprintf("%s invites you to play TicTacToe. click <A HREF=\"chataction.php?USERNAME=%s&CODE=%s&ROOM=%s&WHO=%s&OPERATION=AcceptTicTacToe\" TARGET=LEFT>HERE</A> to accept.",$USERNAME,$WHO,$WHOCODE,$ROOM,$USERNAME,$TEXT);
			Message($USERNAME,$ROOM,$WHO,$TEXT,1);
			$STATUS="TicTacToe Game Invitation Sent To $WHO.";
			break;
		case "AcceptTicTacToe":
			$CODE=GetCode($WHO);
			$TEXT=sprintf("%s Accepts Your Invitation Click <A HREF=\"tictactoe.php?USERNAME=%s&OPPONENT=%s&CODE=%s\" TARGET=LEFT>HERE</A> to Begin.",$USERNAME,$WHO,$USERNAME,$CODE);
			Message($USERNAME,$ROOM,$WHO,$TEXT,1);
			$CODE=GetCode($USERNAME);
			$TIME=GetTime($USERNAME);
			SetUser($USERNAME,$CODE,$ROOM,$WHO,"tictactoe",$TIME);
			$CODE=GetCode($WHO);
			$TIME=GetTime($WHO);
			SetUser($WHO,$CODE,$ROOM,$USERNAME,"tictactoe",$TIME);
			$CODE=GetCode($USERNAME);
			header("Location: tictactoe.php?USERNAME=$USERNAME&OPPONENT=$WHO&CODE=$CODE");
			exit;
		case "Play Checkers":
			if ($WHO=="ALL") { $STATUS="Must Pick Someone To Invite!"; break; };
			$WHOCODE=GetCode($WHO);
			$TEXT=sprintf("%s invites you to play Checkers. click <A HREF=\"chataction.php?USERNAME=%s&CODE=%s&ROOM=%s&WHO=%s&OPERATION=AcceptCheckers\" TARGET=LEFT>HERE</A> to accept.",$USERNAME,$WHO,$WHOCODE,$ROOM,$USERNAME,$TEXT);
			Message($USERNAME,$ROOM,$WHO,$TEXT,1);
			$STATUS="Checkers Game Invitation Sent To $WHO.";
			break;
		case "AcceptCheckers":
			$CODE=GetCode($WHO);
			$TEXT=sprintf("%s Accepts Your Invitation Click <A HREF=\"checkers.php?USERNAME=%s&OPPONENT=%s&CODE=$CODE\" TARGET=LEFT>HERE</A> to Begin.",$USERNAME,$WHO,$USERNAME,$CODE);
			Message($USERNAME,$ROOM,$WHO,$TEXT,1);
			$CODE=GetCode($USERNAME);
			$TIME=GetTime($USERNAME);
			SetUser($USERNAME,$CODE,$ROOM,$WHO,"checkers",$TIME);
			$CODE=GetCode($WHO);
			$TIME=GetTime($WHO);
			SetUser($WHO,$CODE,$ROOM,$USERNAME,"checkers",$TIME);
			$CODE=GetCode($USERNAME);
			header("Location: checkers.php?USERNAME=$USERNAME&OPPONENT=$WHO&CODE=$CODE");
			exit;
		case "Play Chess":
			if ($WHO=="ALL") { $STATUS="Must Pick Someone To Invite!"; break; };
			$WHOCODE=GetCode($WHO);
			$TEXT=sprintf("%s invites you to play Chess. click <A HREF=\"chataction.php?USERNAME=%s&CODE=%s&ROOM=%s&WHO=%s&OPERATION=AcceptChess\" TARGET=LEFT>HERE</A> to accept.",$USERNAME,$WHO,$WHOCODE,$ROOM,$USERNAME,$TEXT);
			Message($USERNAME,$ROOM,$WHO,$TEXT,1);
			$STATUS="Chess Game Invitation Sent To $WHO.";
			break;
		case "AcceptChess":
			$CODE=GetCode($WHO);
			$TEXT=sprintf("%s Accepts Your Invitation Click <A HREF=\"chess.php?USERNAME=%s&OPPONENT=%s&CODE=%s\" TARGET=LEFT>HERE</A> to Begin.",$USERNAME,$WHO,$USERNAME,$CODE);
			Message($USERNAME,$ROOM,$WHO,$TEXT,1);
			$CODE=GetCode($USERNAME);
			$TIME=GetTime($USERNAME);
			SetUser($USERNAME,$CODE,$ROOM,$WHO,"chess",$TIME);
			$CODE=GetCode($WHO);
			$TIME=GetTime($WHO);
			SetUser($WHO,$CODE,$ROOM,$USERNAME,"chess",$TIME);
			$CODE=GetCode($USERNAME);
			header("Location: chess.php?USERNAME=$USERNAME&OPPONENT=$WHO&CODE=$CODE");
			exit;
		case "Play Hangman":
			if ($WHO=="ALL") { $STATUS="Must Pick Someone To Invite!"; break; };
			$WHOCODE=GetCode($WHO);
			$TEXT=sprintf("%s invites you to play Hangman. click <A HREF=\"chataction.php?USERNAME=%s&CODE=%s&ROOM=%s&WHO=%s&OPERATION=AcceptHangman\" TARGET=LEFT>HERE</A> to accept.",$USERNAME,$WHO,$WHOCODE,$ROOM,$USERNAME,$TEXT);
			Message($USERNAME,$ROOM,$WHO,$TEXT,1);
			$STATUS="Hangman Game Invitation Sent To $WHO.";
			break;
		case "AcceptHangman":
			$CODE=GetCode($WHO);
			$TEXT=sprintf("%s Accepts Your Invitation Click <A HREF=\"hangman.php?USERNAME=%s&OPPONENT=%s&CODE=%s\" TARGET=LEFT>HERE</A> to Begin.",$USERNAME,$WHO,$USERNAME,$CODE);
			Message($USERNAME,$ROOM,$WHO,$TEXT,1);
			$CODE=GetCode($USERNAME);
			$TIME=GetTime($USERNAME);
			SetUser($USERNAME,$CODE,$ROOM,$WHO,"hangman",$TIME);
			$CODE=GetCode($WHO);
			$TIME=GetTime($WHO);
			SetUser($WHO,$CODE,$ROOM,$USERNAME,"hangman",$TIME);
			$CODE=GetCode($USERNAME);
			header("Location: hangman.php?USERNAME=$USERNAME&OPPONENT=$WHO&CODE=$CODE");
			exit;
		case "Play Dicezee":
			if ($WHO=="ALL") { $STATUS="Must Pick Someone To Invite!"; break; };
			$WHOCODE=GetCode($WHO);
			$TEXT=sprintf("%s invites you to play Dicezee. click <A HREF=\"chataction.php?USERNAME=%s&CODE=%s&ROOM=%s&WHO=%s&OPERATION=AcceptDicezee\" TARGET=LEFT>HERE</A> to accept.",$USERNAME,$WHO,$WHOCODE,$ROOM,$USERNAME,$TEXT);
			Message($USERNAME,$ROOM,$WHO,$TEXT,1);
			$STATUS="Dicezee Game Invitation Sent To $WHO.";
			break;
		case "AcceptDicezee":
			$CODE=GetCode($WHO);
			$TEXT=sprintf("%s Accepts Your Invitation Click <A HREF=\"dicezee.php?USERNAME=%s&OPPONENT=%s&CODE=%s\" TARGET=LEFT>HERE</A> to Begin.",$USERNAME,$WHO,$USERNAME,$CODE,$CODE);
			Message($USERNAME,$ROOM,$WHO,$TEXT,1);
			$CODE=GetCode($USERNAME);
			$TIME=GetTime($USERNAME);
			SetUser($USERNAME,$CODE,$ROOM,$WHO,"dicezee",$TIME);
			$CODE=GetCode($WHO);
			$TIME=GetTime($WHO);
			SetUser($WHO,$CODE,$ROOM,$USERNAME,"dicezee",$TIME);
			$CODE=GetCode($USERNAME);
			header("Location: dicezee.php?USERNAME=$USERNAME&OPPONENT=$WHO&CODE=$CODE");
			exit;
		case "Play Crossword":
			if ($WHO=="ALL") { $STATUS="Must Pick Someone To Invite!"; break; };
			$WHOCODE=GetCode($WHO);
			$TEXT=sprintf("%s invites you to play Crossword. click <A HREF=\"chataction.php?USERNAME=%s&CODE=%s&ROOM=%s&WHO=%s&OPERATION=AcceptCrossword\" TARGET=LEFT>HERE</A> to accept.",$USERNAME,$WHO,$WHOCODE,$ROOM,$USERNAME,$TEXT);
			Message($USERNAME,$ROOM,$WHO,$TEXT,1);
			$STATUS="Crossword Game Invitation Sent To $WHO.";
			break;
		case "AcceptCrossword":
			$CODE=GetCode($WHO);
			$TEXT=sprintf("%s Accepts Your Invitation Click <A HREF=\"crossword.php?USERNAME=%s&OPPONENT=%s&CODE=%s\" TARGET=LEFT>HERE</A> to Begin.",$USERNAME,$WHO,$USERNAME,$CODE,$CODE);
			Message($USERNAME,$ROOM,$WHO,$TEXT,1);
			$CODE=GetCode($USERNAME);
			$TIME=GetTime($USERNAME);
			SetUser($USERNAME,$CODE,$ROOM,$WHO,"crossword",$TIME);
			$CODE=GetCode($WHO);
			$TIME=GetTime($WHO);
			SetUser($WHO,$CODE,$ROOM,$USERNAME,"crossword",$TIME);
			$CODE=GetCode($USERNAME);
			header("Location: crossword.php?USERNAME=$USERNAME&OPPONENT=$WHO&CODE=$CODE");
			exit;
		default:
			die ("What the heck? I have no idea what just came out of the chat panel!! Report this if it persists please...");
	};
	$STATUS=urlencode($STATUS);
	header("Location: chatpanel.php?ROOM=$ROOM&USERNAME=$USERNAME&WHO=$WHO&CODE=$CODE&STATUS=$STATUS&CHATCOLOR=$CHATCOLOR&REJECTED=$REJECTED");
?>
