<?
	// Returns total number of users on
	function CountUsers() {
	        $Count=0;
		$CurrentUsersFile=fopen("currentusers","r");
		if (!($CurrentUsersFile)) die ("Couldn't Open currentusers... please report if problem persists...");
		flock($CurrentUsersFile,LOCK_SH);
		while (!feof($CurrentUsersFile)) {
			$Line=fgetcsv($CurrentUsersFile,255,":");
			if ($Line[2]!="") ++$Count;	
		}
		flock($CurrentUsersFile,LOCK_UN);
		fclose($CurrentUsersFile);		
		return $Count;
	}

	// Returns current number of users in specified room
	function CountRoom($room) {
	        $CountInRoom=0;
		$CurrentUsersFile=fopen("currentusers","r");
		if (!($CurrentUsersFile)) die ("Couldn't Open currentusers... please report if problem persists...");
		flock($CurrentUsersFile,LOCK_SH);
		while (!feof($CurrentUsersFile)) {
			$Line=fgetcsv($CurrentUsersFile,255,":");
			if ($Line[2]==$room) ++$CountInRoom;	
		}
		flock($CurrentUsersFile,LOCK_UN);
		fclose($CurrentUsersFile);		
		return $CountInRoom;
	}

	function GetCode($user) {
		$found=0;
		$CurrentUsersFile=fopen("currentusers","r");
		if (!($CurrentUsersFile)) die ("Couldn't Open currentusers... please report if problem persists...");
		flock($CurrentUsersFile,LOCK_SH);
		while ((!feof($CurrentUsersFile))&&($found==0)) {
			$Line=fgetcsv($CurrentUsersFile,255,":");
			if ($Line[0]==$user) {
				$CurrentCODE=$Line[1];
				$found=1;
			}			
		}
		if ($found==0) die ("Couldn't find Account in Current Users!!");
		flock($CurrentUsersFile,LOCK_UN);
		fclose($CurrentUsersFile);
		return($CurrentCODE);		
	}

	function GetRoom($user) {
		$found=0;
		$CurrentUsersFile=fopen("currentusers","r");
		if (!($CurrentUsersFile)) die ("Couldn't Open currentusers... please report if problem persists...");
		flock($CurrentUsersFile,LOCK_SH);
		while ((!feof($CurrentUsersFile))&&($found==0)) {
			$Line=fgetcsv($CurrentUsersFile,255,":");
			if ($Line[0]==$user) {
				$CurrentROOM=$Line[2];
				$found=1;
			}			
		}
		if ($found==0) die ("Couldn't find Account in Current Users!!");
		flock($CurrentUsersFile,LOCK_UN);
		fclose($CurrentUsersFile);
		return($CurrentROOM);		
	}

	function GetPartner($user) {
		$found=0;
		$CurrentUsersFile=fopen("currentusers","r");
		if (!($CurrentUsersFile)) die ("Couldn't Open currentusers... please report if problem persists...");
		flock($CurrentUsersFile,LOCK_SH);
		while ((!feof($CurrentUsersFile))&&($found==0)) {
			$Line=fgetcsv($CurrentUsersFile,255,":");
			if ($Line[0]==$user) {
				$CurrentCODE=$Line[1];
				$CurrentROOM=$Line[2];
				$CurrentPARTNER=$Line[3];
				$CurrentGAME=$Line[4];
				$CurrentTIME=$Line[5];
				$found=1;
			}			
		}
		if ($found==0) print ("<CENTER>Couldn't find Account in Current Users!! Maybe they left!");
		flock($CurrentUsersFile,LOCK_UN);
		fclose($CurrentUsersFile);
		return($CurrentPARTNER);		
	}

	function GetTime($user) {
		$found=0;
		$CurrentUsersFile=fopen("currentusers","r");
		if (!($CurrentUsersFile)) die ("Couldn't Open currentusers... please report if problem persists...");
		flock($CurrentUsersFile,LOCK_SH);
		while ((!feof($CurrentUsersFile))&&($found==0)) {
			$Line=fgetcsv($CurrentUsersFile,255,":");
			if ($Line[0]==$user) {
				$CurrentTIME=$Line[5];
				$found=1;
			}			
		}
		if ($found==0) die ("Couldn't find Account in Current Users!!");
		flock($CurrentUsersFile,LOCK_UN);
		fclose($CurrentUsersFile);
		return($CurrentTIME);		
	}

	function GetGame($user) {
		$found=0;
		$CurrentUsersFile=fopen("currentusers","r");
		if (!($CurrentUsersFile)) die ("Couldn't Open currentusers... please report if problem persists...");
		flock($CurrentUsersFile,LOCK_SH);
		while ((!feof($CurrentUsersFile))&&($found==0)) {
			$Line=fgetcsv($CurrentUsersFile,255,":");
			if ($Line[0]==$user) {
				$CurrentCODE=$Line[1];
				$CurrentROOM=$Line[2];
				$CurrentPARTNER=$Line[3];
				$CurrentGAME=$Line[4];
				$CurrentTIME=$Line[5];
				$found=1;
			}			
		}
		if ($found==0) die ("Couldn't find Account in Current Users!!");
		flock($CurrentUsersFile,LOCK_UN);
		fclose($CurrentUsersFile);
		return($CurrentGAME);		
	}

	function SetUser($user,$code,$room,$partner,$game,$time) {
		$found=-1;
		$CurrentUsersFile=fopen("currentusers","r");
		if (!($CurrentUsersFile)) die ("Couldn't Open currentusers... please report if problem persists...");
		flock($CurrentUsersFile,LOCK_SH);
		$y=0;
		while (!feof($CurrentUsersFile)) {
			$Line=fgetcsv($CurrentUsersFile,255,":");
			$File[$y][0]=$Line[0];
			$File[$y][1]=$Line[1];
			$File[$y][2]=$Line[2];
			$File[$y][3]=$Line[3];
			$File[$y][4]=$Line[4];
			$File[$y][5]=$Line[5];
			$File[$y][6]=$Line[6];
			if ($Line[0]==$user) $found=$y;
			if ($Line[0]!="") $y++;			
		}
		if ($found!=-1) --$y;
		if ($found==-1) $found=$y;
		flock($CurrentUsersFile,LOCK_UN);
		fclose($CurrentUsersFile);

		$File[$found][0]=$user;
		$File[$found][1]=$code;
		$File[$found][2]=$room;
		$File[$found][3]=$partner;
		$File[$found][4]=$game;
		$File[$found][5]=$time;
		$File[$found][6]=time();

		$CurrentUsersFile=fopen("currentusers","w");
		if (!($CurrentUsersFile)) die ("Couldn't Open currentusers... please report if problem persists...");
		flock($CurrentUsersFile,LOCK_EX);
		for ($x=0; $x<=$y; $x++) {
			if ($File[$x][0]!="") {
				$NewLine=sprintf("%s:%s:%s:%s:%s:%s:%s\n",$File[$x][0],$File[$x][1],$File[$x][2],$File[$x][3],$File[$x][4],$File[$x][5],$File[$x][6]);
				fputs($CurrentUsersFile,$NewLine);
			}
		}
		flock($CurrentUsersFile,LOCK_UN);
		fclose($CurrentUsersFile);
	}

	function RemoveUser($user) {
		$found=-1;
		$CurrentUsersFile=fopen("currentusers","r");
		flock($CurrentUsersFile,LOCK_SH);
		if (!($CurrentUsersFile)) die ("Couldn't Open currentusers... please report if problem persists...");
		$y=0;
		while (!feof($CurrentUsersFile)) {
			$Line=fgetcsv($CurrentUsersFile,255,":");
			$File[$y][0]=$Line[0];
			$File[$y][1]=$Line[1];
			$File[$y][2]=$Line[2];
			$File[$y][3]=$Line[3];
			$File[$y][4]=$Line[4];
			$File[$y][5]=$Line[5];
			$File[$y][6]=$Line[6];
			if ($Line[0]==$user) $found=$y;
			if ($Line[0]!="") $y++;			
		}
		if (($y==0)&&($File[0][0]=="")) $found=0;
		if ($found!=-1) --$y;
		if ($found==-1) die ("Couldn't Find User to Logout!!");
		flock($CurrentUsersFile,LOCK_UN);
		fclose($CurrentUsersFile);

		$CurrentUsersFile=fopen("currentusers","w");
		if (!($CurrentUsersFile)) die ("Couldn't Open currentusers... please report if problem persists...");
		flock($CurrentUsersFile,LOCK_EX);
		for ($x=0; $x<=$y; $x++) {
			if (($File[$x][0]!="")&&($File[$x][0]!=$user)) {
				$NewLine=sprintf("%s:%s:%s:%s:%s:%s:%s\n",$File[$x][0],$File[$x][1],$File[$x][2],$File[$x][3],$File[$x][4],$File[$x][5],$File[$x][6]);
				fputs($CurrentUsersFile,$NewLine);
			}
		}
		flock($CurrentUsersFile,LOCK_UN);
		fclose($CurrentUsersFile);
	}

?>
